<template>
    <div class="container checkout">
        <div class="row justify-content-center pt-2">
            <div class="col-md-8">
                <div class="card checkout-address p-4">
                    <div class="d-flex title align-items-center fs-4 pb-3">
                        <i class="fa-solid fa-location-dot"></i>
                        <span class="px-2">Địa Chỉ Nhận Hàng</span>
                    </div>
                    <div class="d-flex align-items-center">
                        <div class="fs-5">
                            <span class="name">
                                {{ user.name }}
                            </span>
                            <span v-if="formOrder.phone"> (+84) {{ formOrder.phone }}</span>
                            <span v-if="formOrder.address" class="fs-5 px-2">
                                {{ formOrder.address }}
                            </span>
                        </div>
                        
                    </div>
                    <a href="javascript:void(0)" ref="openModalAddr" data-toggle="modal" data-target="#exampleModalCenter" class="py-2">
                        <template v-if="!formOrder.address || !formOrder.phone">
                            <i class="fa-solid fa-plus"></i> Thêm địa chỉ nhận hàng
                        </template>
                        <template v-else>
                            <i class="fa-solid fa-pen-to-square"></i> 
                            Thay đổi
                        </template>
                    </a>
                </div>
                <div class="card checkout-address p-4 mt-3">
                    <div class="d-flex title align-items-center fs-4 pb-3">
                        Sản phẩm
                    </div>
                    <div class="checkout-product">
                        <template v-for="(cart,index) in products" :key="index">
                            <div class="d-flex">
                                <div class="p-3 pe-0">
                                    <img :src="cart.products.thumbnail" width="100" height="100" alt="">
                                </div>
                                <div class="w-100">
                                    <div class="p-2 d-flex justify-content-between w-100">
                                        <div class="product-name">
                                            <span class="fs-3 fw-600">
                                                {{ cart.products.name }}
                                            </span>
                                        </div>
                                    </div>
                                    <div class="d-flex justify-content-between px-2">
                                        <div>
                                            <div class="fs-5">Số lượng: {{ cart.quantity }}</div>
                                            <div class="fs-5 ">Đơn giá: 
                                                <span class="price fs-5">
                                                    {{ new Intl.NumberFormat().format((cart.products.price * (100-cart.products.sale) / 100 )) }}
                                                </span>
                                            </div>
                                        </div>
                                        <div v-if="cart.products.quantity > 0" class="product-price text-end">
                                            <div class="fs-5">Thành tiền</div>
                                            <div class="fs-4 price">{{ new Intl.NumberFormat().format( ((cart.products.price * (100-cart.products.sale) / 100 ) * cart.quantity)) }}đ</div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="pay-online">
                                <span>Khuyến mại thanh toán</span>
                                <div class="sale-pay">Giảm ngay 5% tối đa 100.000 đồng khi thanh toán online</div>
                            </div>
                        </template>
                    </div>
                </div>
                <div class="card checkout-address mt-3 p-4">
                    <div class="d-flex title align-items-center justify-content-between fs-4 pb-3">
                        <div>
                            <i class="fa-solid fa-tag"></i>
                            <span class="px-2">Voucher</span>
                        </div>
                        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#exampleModalScrollable">
                            Chọn voucher
                        </button>
                    </div>
                    <div v-if="voucherSelect" class="card mb-2 d-flex justify-content-between"  style="flex-direction: row; padding: 15px;" >
                        <div class="d-flex">
                            <img src="assets/img/voucher.png" alt="" height="100" width="100">
                            <div class="voucher-detail m-2">
                                <h5>{{ voucherSelect.name }}</h5>
                                <p>{{ voucherSelect.description }}</p>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="card checkout-address mt-3 p-4">
                    <div class="d-flex title align-items-center fs-4 pb-3">
                        <i class="fa-regular fa-credit-card"></i>
                        <span class="px-2">Phương thức thanh toán</span>    
                    </div>
                    <div class="">
                        <div class="form-check">
                            <input @change="checkPayment()" class="form-check-input" type="radio" v-model="formOrder.payment_type"  id="cod" :value="0">
                            <label class="form-check-label" for="cod">
                                Thanh toán khi nhận hàng
                            </label>
                        </div>
                        <div class="form-check">
                            <input @change="checkPayment()" class="form-check-input" type="radio" v-model="formOrder.payment_type" id="online" :value="1">
                            <label class="form-check-label" for="online">
                                Thanh toán online
                            </label>
                        </div>
                        <hr>
                        <div class="row justify-content-end">
                            <div class="col-5">
                                <div class="d-flex payment-checkout py-2 justify-content-between">
                                    <span>
                                        Tổng tiền hàng:
                                    </span>
                                    <span>
                                        {{ new Intl.NumberFormat().format( formOrder.total ) }}đ
                                    </span>
                                </div>
                                <div class="d-flex payment-checkout py-2 justify-content-between">
                                    <span>
                                        Khuyến mại:
                                    </span>
                                    <span>
                                        {{ new Intl.NumberFormat().format( formOrder.sale > 0 ? -formOrder.sale : 0 ) }}đ
                                    </span>
                                </div>
                                <div class="d-flex payment-checkout py-2 justify-content-between">
                                    <span>
                                        Voucher:
                                    </span>
                                    <span>
                                        {{ new Intl.NumberFormat().format( formOrder.voucher_discount > 0 ? -formOrder.voucher_discount : 0 ) }}đ
                                    </span>
                                </div>
                                <div class="d-flex payment-checkout py-2 justify-content-between">
                                    <span>
                                        Phí vận chuyển:
                                    </span>
                                    <span>
                                        {{ new Intl.NumberFormat().format( formOrder.ship ) }}đ
                                    </span>
                                </div>
                                <div class="d-flex payment-checkout py-2 justify-content-between">
                                    <span class="fs-5">
                                        Tổng thanh toán:
                                    </span>
                                    <span class="fs-3 price">
                                        {{ new Intl.NumberFormat().format( formOrder.total_pay ) }}đ
                                    </span>
                                </div>
                            </div>
                        </div>
                        <hr>
                        <div class="d-flex justify-content-between">
                            <span class="text-confirm-order w-50">
                                Nhấn "Đặt hàng" đồng nghĩa với việc bạn đồng ý tuân theo <br> Điều khoản của shop.
                            </span>
                            <button v-on:click="confirm()" class="btn btn-primary px-5 confirm">
                                Đặt hàng
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- modal thêm địa chỉ và số điện thoại -->
    <div class="modal fade" id="exampleModalCenter" data-backdrop="static" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLongTitle">Thêm thông tin địa chỉ nhận hàng</h5>
                    <button type="button" v-on:click="closeModal()" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form class="needs-validation" novalidate>
                        <div class="form-group">
                            <label for="phone">Số điện thoại</label>
                            <input v-model="formAddress.phone" class="form-control" type="text" id="phone" required>
                            <div class="invalid-feedback">
                                Số điện thoại không được để trống.
                            </div>
                        </div>
                        <div class="form-group mt-1">
                            <label for="city">Tỉnh/Thành phố</label>
                            <select @change="getDistrict()" v-model="formAddress.city" class="form-control" id="city" required>
                                <option value="">---Chọn Tỉnh/Thành phố---</option>
                                <template v-for="(item,index) in city" :key="index">
                                    <option :value="item">{{ item.name }}</option>
                                </template>
                            </select>
                            <div class="invalid-feedback">
                               Vui lòng chọn Tỉnh/Thành phố
                            </div>
                        </div>
                        <div class="form-group mt-1">
                            <label for="district">Quận/Huyện</label>
                            <select @change="getArea()" :disabled="!formAddress.city" v-model="formAddress.district" class="form-control" id="district" required>
                                <option value="">---Chọn Quận/Huyện---</option>
                                <template v-for="(item,index) in district" :key="index">
                                    <option :value="item">{{ item.name }}</option>
                                </template>
                            </select>
                            <div class="invalid-feedback">
                               Vui lòng chọn Quận/Huyện
                            </div>
                        </div>
                        <div class="form-group mt-1">
                            <label for="area">Xã/Phường/Thị trấn</label>
                            <select :disabled="!formAddress.city || !formAddress.district" v-model="formAddress.area" class="form-control" id="area" required>
                                <option value="">---Chọn Xã/Phường/Thị trấn---</option>
                                <template v-for="(item,index) in area" :key="index">
                                    <option :value="item">{{ item.name }}</option>
                                </template>
                            </select>
                            <div class="invalid-feedback">
                               Vui lòng chọn Xã/Phường/Thị trấn
                            </div>
                        </div>
                        <div class="form-group mt-1">
                            <label for="note">Địa chỉ chi tiết:</label>
                            <input v-model="formAddress.address_note" class="form-control" type="text" name="" id="note" required>
                            <div class="invalid-feedback">
                               Vui lòng nhập địa chỉ chi tiết
                            </div>
                        </div>
                        <div class="modal-footer pb-0">
                            <button v-on:click="closeModal()" ref="closeModalAddress" type="button" class="btn btn-secondary" data-dismiss="modal">Đóng</button>
                            <button type="button" v-on:click="saveAddress()" class="btn btn-primary">Lưu</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>

    <!-- Modal voucher-->
    <div class="modal fade" id="exampleModalScrollable" tabindex="-1" role="dialog" aria-labelledby="exampleModalScrollableTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-scrollable" role="document">
            <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalScrollableTitle">Voucher</h5>
                <button type="button" class="btn" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body voucher-list">
                <template v-for="(item,index) in voucher" :key="index">
                    <div class="card mb-2 d-flex justify-content-between" :class="{'not-use': formOrder.total_pay < item.min || item.expires === 0 }" :for="'voucher'+item.id" style="flex-direction: row; padding: 15px;" >
                        <div class="d-flex">
                            <img src="assets/img/voucher.png" alt="" height="100" width="100">
                            <div class="voucher-detail m-2">
                                <h5>{{ item.name }}</h5> {{ item.expires }}
                                <p>{{ item.description }}</p>
                                <p v-if="formOrder.total_pay < item.min" class="text-danger">Đơn hàng chưa đặt giá trị tối thiểu.</p>
                                <p v-if="item.expires === 0" class="text-danger">Voucher hết hạn</p>
                            </div>
                        </div>
                        <input :disabled="formOrder.total_pay < item.min || item.expires === 0" type="radio" v-model="formOrder.voucher_id" :id="'voucher'+item.id" class="form-check-input m-auto" :value="item.id">
                    </div>
                </template>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Đóng</button>
                <button type="button" data-dismiss="modal" v-on:click="selectVoucher()" class="btn btn-primary">Áp dụng</button>
            </div>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        name: 'checkout',
        data(){
            return {
                city: null,
                district: null,
                area: null,
                formAddress: {
                    city: '',
                    district: '',
                    area: '',
                    address_note: '',
                    phone: '',
                    errors: []
                },
                formOrder: {
                    address: '',
                    phone: '',
                    payment_type: 0,
                    total: 0,
                    total_pay: 0,
                    sale: 0,
                    ship: 0,
                    voucher_id: 0,
                    voucher_discount: 0
                },
                voucherSelect: null
            }
        },
        props:{
            products:{
                type: Array,
                requied: true
            },
            user:{
                type: Object,
                requied: true
            },
            voucher: {
                type: Object,
                required: true
            }
        },
        methods:{
            getCity(){
                this.$store.dispatch('listCity').then(res =>{
                    this.city = res.data;
                });
            },
            getDistrict(){
                if(!this.formAddress.city) return;
                this.formAddress.district = '';
                this.formAddress.area = '';
                this.$store.dispatch('listDistrict',{'city_code' : this.formAddress.city.city_code}).then(res =>{
                    this.district = res.data;
                });
            },
            getArea(){
                if(!this.formAddress.city || !this.formAddress.district) return;
                this.$store.dispatch('listArea',{'district_code' : this.formAddress.district.district_code}).then(res =>{
                    this.area = res.data;
                });
            },
            selectVoucher(){
                this.voucherSelect = this.voucher.find((item) => {
                    if(item.id == this.formOrder.voucher_id) {
                        this.formOrder.voucher_discount = item.discount
                        return item;
                    }
                });
                this.checkPayment();
            },
            saveAddress(){
                var forms = document.querySelectorAll('.needs-validation');
                let error = false;
                Array.prototype.slice.call(forms).forEach(function (form) {
                    form.classList.add('was-validated');
                    error = !form.checkValidity();
                })
                if(error) return;
                this.formOrder.address = this.formAddress.address_note 
                    + ', '+ this.formAddress.area.name 
                    + ', ' + this.formAddress.district.name 
                    + ', ' + this.formAddress.city.name;
                this.formOrder.phone = this.formAddress.phone;
                this.$refs.closeModalAddress.click();
            },
            closeModal(){
                this.formAddress = {
                    city: '',
                    district: '',
                    area: '',
                    address_note: '',
                    phone: '',
                    errors: []
                };
            },
            checkPayment(){
                let total_pay = 0;

                this.products.map((product) => {
                    total_pay += ((product.products.price * (100-product.products.sale) / 100 ) * product.quantity);
                });
                this.formOrder.total = total_pay;

                if(this.formOrder.payment_type === 1) {
                    let sale = total_pay*0.9;
                    if(sale>100000) {
                        total_pay -= 100000
                        this.formOrder.sale = 100000;
                    }
                    else {
                        total_pay -= sale;
                        this.formOrder.sale = sale;
                    }
                } else {
                    this.formOrder.sale = 0;
                }
                if(this.formOrder.voucher_discount > 0) {
                    total_pay -= this.formOrder.voucher_discount;
                }
                this.formOrder.total_pay = total_pay;
            },
            confirm(){
                if(!this.formOrder.address) {
                    this.$refs.openModalAddr.click()
                    return;
                }
                this.$store.dispatch('payment',this.formOrder).then(res =>{
                    console.log(res);
                    if(res.code == '00') {
                        window.location= `${ res.data}`;
                    }
                    if(res.status === 200) {
                        window.location.href= 'chi-tiet-don-hang?order_code='+ res.data.code
                    }
                });
            },
        },
        mounted() {
            this.getCity();
            this.formOrder.address = this.user.address;
            this.formOrder.phone = this.user.phone;
            this.checkPayment();
        }
    }
</script>
<style lang="scss">
.checkout {
    color: #212121;
    .checkout-address {
        .name {
            font-weight: 600;
        }
        .title{
            font-weight: 600;
            color: #cb1c22;
        }
    }
    .payment-checkout {
        align-items: baseline;
    }
    .text-confirm-order {
        font-size: 12px;
    }
    .confirm{
        background-color: #cb1c22;
        border-color: #cb1c22;
        box-shadow: none
    }
}
.not-use {
    background-color: #e8e8e8 !important;
    opacity: 0.7;
}
.voucher-list {
    p{
        margin-bottom: 5px !important;
    }
    h5{
        margin-bottom: 10px !important;
        color: #233446;
    }
}
</style>